/*
   (c) Copyright 2010 Quadbyte
   Define all Mikrokopter structures dialog via MK USB for TinyTools

   New structure must be a javascript Object and must contains a 'cmd' property
   Do not forget to fill in the genrale property at the end of the this file

   C type is converted as follow :
   signed int    : s16
   signed char   : s8
   unsigned int  : u16
   unsigned char : u8
*/



/*
struct str_WinkelOut
{
   signed int  Winkel[2];
 unsigned char UserParameter[2];
 unsigned char CalcState;
 unsigned char Orientation;
};
*/

var str_WinkelOut = new Object();
str_WinkelOut.cmd = "k";
str_WinkelOut.nickAngle = "s16";
str_WinkelOut.rollAngle = "s16";
str_WinkelOut.userParameter = "u8[2]";
str_WinkelOut.calcState = "u8";
str_WinkelOut.orientation = "u8";



/*
struct str_VersionInfo
{
  unsigned char SWMajor;
  unsigned char SWMinor;
  unsigned char ProtoMajor;
  unsigned char ProtoMinor;
  unsigned char SWPatch;
  unsigned char HardwareError[5];
};
*/

var str_VersionInfo = new Object();
str_VersionInfo.cmd = "V";
str_VersionInfo.major = "u8";
str_VersionInfo.minor = "u8";
str_VersionInfo.protoMajor = "u8";
str_VersionInfo.protoMinor = "u8";
str_VersionInfo.patch = "u8";
str_VersionInfo.hardwareError = "u8[5]";

/*
typedef struct
{
        uint8_t Revision;
    int8_t Name[12];
    int8_t Motor[16][4];
    uint8_t crc;
} __attribute__((packed)) MixerTable_t;
*/

var MixerTable_t = new Object();
MixerTable_t.cmd = "N";
MixerTable_t.revision = "u8";
MixerTable_t.name = "s8[12]";
MixerTable_t.motor1 = "u8[4]"; //"Gaz: %u8 Nick: %u8 Roll: %u8 Yaw: %u8";
MixerTable_t.motor2 = "u8[4]";
MixerTable_t.motor3 = "u8[4]";
MixerTable_t.motor4 = "u8[4]";
MixerTable_t.motor5 = "u8[4]";
MixerTable_t.motor6 = "u8[4]";
MixerTable_t.motor7 = "u8[4]";
MixerTable_t.motor8 = "u8[4]";
MixerTable_t.motor9 = "u8[4]";
MixerTable_t.motor10 = "u8[4]";
MixerTable_t.motor11 = "u8[4]";
MixerTable_t.motor12 = "u8[4]";
MixerTable_t.motor13 = "u8[4]";
MixerTable_t.motor14 = "u8[4]";
MixerTable_t.motor15 = "u8[4]";
MixerTable_t.motor16 = "u8[4]";
MixerTable_t.crc = "u8";


/*
extern volatile int PPM_in[26];
*/

var PPM_in = new Object();
PPM_in.cmd = "P";
PPM_in.v1 = "s16";
PPM_in.v2 = "s16";
PPM_in.v3 = "s16";
PPM_in.v4 = "s16";
PPM_in.v5 = "s16";
PPM_in.v6 = "s16";
PPM_in.v7 = "s16";
PPM_in.v8 = "s16";
PPM_in.v9 = "s16";
PPM_in.v10 = "s16";
PPM_in.v11 = "s16";
PPM_in.v12 = "s16";
PPM_in.v13 = "s16";
PPM_in.v14 = "s16";
PPM_in.v15 = "s16";
PPM_in.v16 = "s16";



/*
extern unsigned char MenuePunkt;
extern unsigned char MaxMenue;
extern char DisplayBuff[80];
*/

var Menu = new Object();
Menu.cmd = "L";
Menu.menuItem = "u8";
Menu.maxMenuItem = "u8";
Menu.text = "s8[80]";


/*
unsigned char DebugTextAnforderung = 255;
unsigned char label[16]; // local sram buffer
*/

var LabelValues = new Object();
LabelValues.cmd = "A";
LabelValues.index = "u8";
LabelValues.value = "s8[16]";



/*
unsigned char tempchar1, tempchar2;
unsigned char address;
typedef struct
{
        uint8_t Revision;                       // must be BL_REVISION
        uint8_t SetMask;                        // settings mask
        uint8_t PwmScaling;                     // maximum value of control pwm, acts like a thrust limit
        uint8_t CurrentLimit;           // current limit in A
        uint8_t TempLimit;                      // in °C
        uint8_t CurrentScaling;         // scaling factor for current measurement
        uint8_t BitConfig;                      // see defines above
        uint8_t crc;                            // checksum
}  __attribute__((packed)) BLConfig_t;

*/

var BlConfig = new Object();
BlConfig.cmd = "U";
BlConfig.status1 = "u8";
BlConfig.status2 = "u8";
BlConfig.address = "u8";
BlConfig.revision = "u8";
BlConfig.setMask = "u8";
BlConfig.pwmScaling = "u8";
BlConfig.currentLimit = "u8";
BlConfig.tempLimit = "u8";
BlConfig.currentScaling = "u8";
BlConfig.bitConfig = "u8";
BlConfig.crc = "u8";


/*
struct str_DebugOut
{
 unsigned char Status[2];
 signed int Analog[32];    // Debugwerte
};
*/

var str_DebugOut = new Object();
str_DebugOut.cmd = "D";
str_DebugOut.status = "u8[2]";
str_DebugOut.analog = "s16[32]";









// add a new property for each new structure defined upper

({
   str_WinkelOut : "struct",
   str_VersionInfo : "struct",
   MixerTable_t : "struct",
   PPM_in : "struct",
   Menu : "struct",
   LabelValues : "struct",
   BlConfig : "struct",
   str_DebugOut : "struct"
})

//debugger;
